# operator==,!=(std::function)

From cppreference.com
< cpp‎ | utility‎ | functional‎ | function

template< class R, class... ArgTypes > bool operator==( const std::function <R(ArgTypes...)>& f, std::nullptr_t ) noexcept; | (1) | (since C++11)
template< class R, class... ArgTypes > bool operator==( std::nullptr_t, const std::function <R(ArgTypes...)>& f ) noexcept; | (2) | (since C++11)
template< class R, class... ArgTypes > bool operator!=( const std::function <R(ArgTypes...)>& f, std::nullptr_t ) noexcept; | (3) | (since C++11)
template< class R, class... ArgTypes > bool operator!=( std::nullptr_t, const std::function <R(ArgTypes...)>& f ) noexcept; | (4) | (since C++11)

Compares a `std::function` with a null pointer. Empty functions (that is, functions without a callable target) compare equal, non-empty functions compare non-equal.

### Parameters

f | - | `std::function` to compare

### Return value

1-2) !f
3-4) (bool) f

### Example

Run this code

    #include <functional>
    #include <iostream>

    using SomeVoidFunc = std::function<void(int)>;

    class C {
    public:
        C(SomeVoidFunc void_func = nullptr) :
            void_func_(void_func)
        {
            if (void_func_ == nullptr) { // specialized compare with nullptr
                void_func_ = std::bind(&C::default_func, this, std::placeholders::_1);
            }
            void_func_(7);
        }

        void default_func(int i) { std::cout << i << '\n'; };

    private:
        SomeVoidFunc void_func_;
    };

    void user_func(int i)
    {
        std::cout << (i + 1) << '\n';
    }

    int main()
    {
        C c1;
        C c2(user_func);
    }

Output:

    7
    8

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/utility/functional/function/operator_cmp&oldid=93397"